Arch BuildingPart

From FreeCAD Documentation
Revision as of 18:19, 19 February 2020 by Renatorivo (talk | contribs)

Arch BuildingPart

Menu location
Arch → BuildingPart
Workbenches
Arch
Default shortcut
None
Introduced in version
0.18
See also
Arch Building, Arch Site

Description

The BuildingPart replaces the old Arch Floor and Arch Building with a more capable version that can be used not only to create Floor/Storey/Levels but also all kinds of situations where different Arch/BIM objects need to be grouped and that group might need to be handled as one object or replicated.

Usage

  1. Optionally, select one or more objects to be included in your new Building Part.
  2. Press the Arch BuildingPart button.

Options

  • After creating a BuildingPart, you can add more objects to it by dragging and dropping them in the Tree View or by using the Arch Add tool.
  • You can remove objects from a BuildingPart by dragging and dropping them out of the Tree View or by using the Arch Remove tool.
  • By double-clicking the BuildingPart object in the tree view, the Working Plane will be set to its location, and the BuildingPart will become active, which means that new objects will be added automatically to it. Double-clicking the BuildingPart again will deactivate it and set the working plane back to its previous position.
  • The BuildingPart can display a mark in the 3D view with a label and level indication.
  • When a BuildingPart is moved/rotated, all its children that either have no DataMove With Host property, or have it turned on, will move/rotate together.
  • Building Parts can be Draft Cloned.
  • Building Parts can take any IFC type. Its IFC Role property determines its use. If you set it to Building Storey it will behave as a level. If you set it to Building it behaves as a building, and if you set it to Element Assembly it behaves as an assembly. Its icon will change to reflect this setting, but other than that it has no other impact in FreeCAD. However, being exported to IFC as one or another type can have an impact in other BIM applications.

Properties

Data

  • DataHeight: The height of this object, and of its children objects. The children objects could be, for example, Arch Walls. Each wall's height must be set to 0 (zero), so the height property of the BuildingPart propagates to the objects inside of it.
  • DataLevelOffset: The level of the (0,0,0) point of this level. This value is added to the Placement.Base.z attribute of the BuildingPart, to indicate a vertical offset without actually moving the object. The resulting offset is displayed if ViewShow Level is true.
  • DataArea: The computed floor area of this floor
  • DataIfcRole: The role of this object
  • DataDescription: An optional description for this component
  • DataTag: An optional tag for this component
  • DataIfcAttributes: Custom IFC properties and attributes

View

  • ViewLineWidth: The line width of this object
  • ViewOverrideUnit: An optional unit to express levels
  • ViewDisplayOffset: A transformation to apply to the level mark
  • ViewShowLevel: If true, show the level
  • ViewShowUnit: If true, show the unit on the level tag
  • ViewSetWorkingPlane: If true, when activated, the working plane will automatically adapt to this Building Part
  • ViewOriginOffset: If true, when activated, Display offset will affect the origin mark too
  • ViewShowLabel: If true, when activated, the object's label is displayed
  • ViewFontName: The font to be used for texts
  • ViewFontSize: The font size of texts
  • ViewRestoreView: If set, the view stored in this object will be restored on double-click
  • ViewDiffuseColor: The individual face colors

introduced in version 0.19

  • ViewChildrenOverride: If set, the settings below will affect the children of this Building Part
  • ViewChildrenLineWidth: The line width to apply to the children of this Building Part
  • ViewChildrenLineColor: The line color to apply to the children of this Building Part
  • ViewChildrenShapeColor: The shape color to apply to the children of this Building Part
  • ViewChildrenTransparency: The transparency to apply to the children of this Building Part

Scripting

See also: Arch API and FreeCAD Scripting Basics.

The BuildingPart tool can be used in macros and from the Python console by using the following function:

BuildingPart = makeBuildingPart(objectslist=None)
  • Creates a BuildingPart object from objectslist, which is a list of objects.

Example:

import FreeCAD, Draft, Arch

p1 = FreeCAD.Vector(0, 0, 0)
p2 = FreeCAD.Vector(2000, 0, 0)
baseline = Draft.makeLine(p1, p2)
baseline2 = Draft.makeLine(p1, -1*p2)

Wall1 = Arch.makeWall(baseline, length=None, width=150, height=2000)
Wall2 = Arch.makeWall(baseline2, length=None, width=150, height=1800)
FreeCAD.ActiveDocument.recompute()

BuildingPart = Arch.makeBuildingPart([Wall1, Wall2])

Floor = Arch.makeFloor([BuildingPart])
Building = Arch.makeBuilding([Floor])
Site = Arch.makeSite(Building)
FreeCAD.ActiveDocument.recompute()